#include "testApp.h"
#include "particle.h"

#include "ofMain.h"

// comparison routine for sort...
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}              
      

//--------------------------------------------------------------
void testApp::setup(){

//    for (int i = 0; i < 500; i++){
//        particle * p = new particle();
//        myParticles.push_back(p);
//        //myParticles[i]->pos.set(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()));
//		//myParticles[i]->setInitialCondition( (i % 200) * 20, (i / 200) * 20,0, 0);
//        myParticles[i]->vel.set(0,0);
//    }

	int width = ofGetWidth();
	int height = ofGetHeight();
	
	int space = 30;
	
    for (int x = 10; x < width; x += space) {
		for (int y = 10; y < height; y += space) {
			particle * p = new particle();
			p->setInitialCondition(x, y, 0, 0);
			p->vel.set(0,0);
			myParticles.push_back(p);
		}
    }
	
	ofSetCircleResolution(6);
	ofSetRectMode(OF_RECTMODE_CENTER);
}

//--------------------------------------------------------------
void testApp::update(){
	
	//cout << ofGetFrameRate() << endl;
	
	// sort all the particle
	sort( myParticles.begin(), myParticles.end(), comparisonFunction );               // sort them!
	
	
	
	ofBackground(0,0,0); //Grey background, NY style
	
    for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->resetForce();
    }
	
	
	for (int i = 0; i < myParticles.size(); i++){
		for (int j = i-1; j >= 0; j--){
			if ( fabs(myParticles[j]->pos.x - myParticles[i]->pos.x) >  10) break;
			
			myParticles[i]->addRepulsionForce( *myParticles[j],10,0.05f);
			myParticles[i]->addCounterClockwiseForce(*myParticles[j],50,0.01f);
		}
    }
	
	
    for (int i = 0; i < myParticles.size(); i++){
		//myParticles[i]->addAttractionForce( 500,500,1500,0.01);
		myParticles[i]->addRepulsionForce( mouseX,mouseY,50,0.7);
		myParticles[i]->addDampingForce();
		
        myParticles[i]->update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofSetColor(255,255,255);
	
	float dist = 0;
	float pcount = 0;
	
	
	// then draw:
	
	for (int i = 0; i < myParticles.size(); i++){
		ofSetColor(100, 0, ofRandom(100, 150));
		 myParticles[i]->draw();
		 
		 //for (int j = 0; j < myParticles.size(); j++)
//			{
//				dist = ofDist(myParticles[i]->pos.x, myParticles[i]->pos.y, myParticles[j]->pos.x, myParticles[j]->pos.y);
//				if(dist < 30)
//				{
//					pcount++;
//					float alpha = ofMap(dist,0, 120, 0, 30);
//					ofSetColor(100, 0, ofRandom(100, 150), 80-alpha);
//					ofBeginShape();
//					ofNoFill();
//						ofVertex(myParticles[i]->pos.x, myParticles[i]->pos.y);
//						ofVertex(myParticles[j]->pos.x, myParticles[j]->pos.y);
//					ofEndShape(false);
//				}
//			}
	 }

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
   
}
//--------------------------------------------------------------
void testApp::keyReleased  (int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
}
